//+------------------------------------------------------------------+
//|         FXR_STAR-GoldSwings                                      |
//+------------------------------------------------------------------+
#property copyright "Uri Meitzar Indicators Portfolio"
#property link      "Uri Meitzar "
#property description   "Version 5.2 , 15/4/2016"
#property indicator_separate_window
#property indicator_buffers 10
#property indicator_color1 clrLime
#property indicator_color2 clrRed
#property indicator_color3 clrLime      
#property indicator_color4 clrRed
#property indicator_color5 clrLime
#property indicator_color6 clrRed
#property indicator_color7 clrLime      
#property indicator_color8 clrRed
#property indicator_color9 clrLime
#property indicator_color10 clrRed
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4
#property indicator_width5 4
#property indicator_width6 4
#property indicator_width7 4
#property indicator_width8 4
#property indicator_width9 4
#property indicator_width10 4
#property indicator_maximum 0.3
#property indicator_minimum 0.0


   enum  TableFiboValues {         // By ENUM nothing of the text is relevant only Position as numbers 
   fibFactor0=0,     //x 0.236
   fibFactor1=1,     //x 0.382
   fibFactor2=2,     //x 0.500
   fibFactor3=3,     //x 0.618
   fibFactor4=4,     //x 0.764
   fibFactor5=5,     //x 1.000
   fibFactor6=6,     //x 1.272
   fibFactor7=7,     //x 1.382
   fibFactor8=8,     //x 1.618
   fibFactor9=9,     //x 2.000
   fibFactor10=10,   //x 2.618 
  };

//-----------------------Input Parameters

extern double xSpeedFactor=1.000;
extern TableFiboValues FiboFactor=fibFactor5; 
extern ENUM_MA_METHOD Spec13Method=MODE_EMA;
extern ENUM_APPLIED_PRICE Spec13Price=PRICE_CLOSE;
extern double FromZero   = 0.05;      

//------- Global Variables ------------------------------------------
double LineUpEMA0[],LineDnEMA0[];
double LineUpEMA1[],LineDnEMA1[];
double LineUpEMA2[],LineDnEMA2[];
double LineUpEMA3[],LineDnEMA3[];
double LineUpEMA4[],LineDnEMA4[];
double ActualMas[] ={3,5,8,13,18,21};
int ShiftPriceLines=0;
double xFiboFactor;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
   CalcFibFactor (FiboFactor); 
   ActualMas[0]=MathMax(MathRound(ActualMas[0]*xFiboFactor*xSpeedFactor),1);
   ActualMas[1]=MathMax(MathRound(ActualMas[1]*xFiboFactor*xSpeedFactor),2);
   ActualMas[2]=MathMax(MathRound(ActualMas[2]*xFiboFactor*xSpeedFactor),3);
   ActualMas[3]=MathMax(MathRound(ActualMas[3]*xFiboFactor*xSpeedFactor),4);
   ActualMas[4]=MathMax(MathRound(ActualMas[4]*xFiboFactor*xSpeedFactor),5);
   ActualMas[5]=MathMax(MathRound(ActualMas[5]*xFiboFactor*xSpeedFactor),6);
   
  IndicatorDigits(2);
  SetIndexBuffer(0, LineUpEMA0);   SetIndexStyle (0, DRAW_LINE); SetIndexLabel (0, ActualMas[0]+"x"+ActualMas[1]+"EMAUp"); 
  SetIndexBuffer(1, LineDnEMA0);  SetIndexStyle (1, DRAW_LINE); SetIndexLabel (1, ActualMas[0]+"x"+ActualMas[1]+"EMADn"); 
  SetIndexBuffer(2, LineUpEMA1);   SetIndexStyle (2, DRAW_LINE); SetIndexLabel (2,ActualMas[1]+"x"+ActualMas[2]+"EMAUp"); 
  SetIndexBuffer(3, LineDnEMA1);  SetIndexStyle (3, DRAW_LINE); SetIndexLabel (3, ActualMas[1]+"x"+ActualMas[2]+"EMADn"); 
  SetIndexBuffer(4, LineUpEMA2);   SetIndexStyle (4, DRAW_LINE); SetIndexLabel (4, ActualMas[2]+"x"+ActualMas[3]+"EMAUp"); 
  SetIndexBuffer(5, LineDnEMA2);  SetIndexStyle (5, DRAW_LINE); SetIndexLabel (5, ActualMas[2]+"x"+ActualMas[3]+"EMADn"); 
  SetIndexBuffer(6, LineUpEMA3);   SetIndexStyle (6, DRAW_LINE); SetIndexLabel (6, ActualMas[3]+"x"+ActualMas[4]+"EMAUp"); 
  SetIndexBuffer(7, LineDnEMA3);  SetIndexStyle (7, DRAW_LINE); SetIndexLabel (7, ActualMas[3]+"x"+ActualMas[4]+"EMADn"); 
  SetIndexBuffer(8, LineUpEMA4);   SetIndexStyle (8, DRAW_LINE); SetIndexLabel (8, ActualMas[4]+"x"+ActualMas[5]+"EMAUp"); 
  SetIndexBuffer(9, LineDnEMA4);  SetIndexStyle (9, DRAW_LINE); SetIndexLabel (9, ActualMas[4]+"x"+ActualMas[5]+"EMADn"); 
  
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  
  int i, counted_bars; 
  
   counted_bars = Bars - IndicatorCounted();
  if (counted_bars<0) return(0);
  if (counted_bars>0) counted_bars--;
  for (i=0; i<counted_bars; i++) {
    LineDnEMA0[i] = FromZero*5;    LineUpEMA0[i] = FromZero*5;
    LineDnEMA1[i] = FromZero*4;    LineUpEMA1[i] = FromZero*4;
    LineDnEMA2[i] = FromZero*3;    LineUpEMA2[i] = FromZero*3;
    LineDnEMA3[i] = FromZero*2;    LineUpEMA3[i] = FromZero*2;
    LineDnEMA4[i] = FromZero*1;    LineUpEMA4[i] = FromZero*1;

    double MaValue0 = iMA(NULL, 0, ActualMas[0], ShiftPriceLines, Spec13Method, Spec13Price, i);
    double MaValue1 = iMA(NULL, 0, ActualMas[1], ShiftPriceLines, Spec13Method, Spec13Price, i);
    double MaValue2 = iMA(NULL, 0, ActualMas[2], ShiftPriceLines, Spec13Method, Spec13Price, i);
    double MaValue3 = iMA(NULL, 0, ActualMas[3], ShiftPriceLines, Spec13Method, Spec13Price, i);
    double MaValue4 = iMA(NULL, 0, ActualMas[4], ShiftPriceLines, Spec13Method, Spec13Price, i);
    double MaValue5 = iMA(NULL, 0, ActualMas[5], ShiftPriceLines, Spec13Method, Spec13Price, i);
    
    if      (MaValue1>MaValue0)     LineUpEMA0[i] = EMPTY_VALUE;
    else if (MaValue1<MaValue0)     LineDnEMA0[i] = EMPTY_VALUE;
    
    if      (MaValue2>MaValue1)     LineUpEMA1[i] = EMPTY_VALUE;
    else if (MaValue2<MaValue1)     LineDnEMA1[i] = EMPTY_VALUE;
    if      (MaValue3>MaValue2)     LineUpEMA2[i] = EMPTY_VALUE;
    else if (MaValue3<MaValue2)     LineDnEMA2[i] = EMPTY_VALUE;
    if      (MaValue4>MaValue3)     LineUpEMA3[i] = EMPTY_VALUE;
    else if (MaValue4<MaValue3)     LineDnEMA3[i] = EMPTY_VALUE;
    if      (MaValue5>MaValue4)     LineUpEMA4[i] = EMPTY_VALUE;
    else if (MaValue5<MaValue4)     LineDnEMA4[i] = EMPTY_VALUE;
  }

 

return(0);
}
//+------------------------------------------------------------------+

//////////////////////////////////////////////////////////////////
double CalcFibFactor (int a) {
   switch (a) {
   case 0:     xFiboFactor=0.236; return (xFiboFactor);
   case 1:     xFiboFactor=0.382; return (xFiboFactor);
   case 2:     xFiboFactor=0.500; return (xFiboFactor);
   case 3:     xFiboFactor=0.618; return (xFiboFactor);
   case 4:     xFiboFactor=0.764; return (xFiboFactor);
   case 5:     xFiboFactor=1.000; return (xFiboFactor);
   case 6:     xFiboFactor=1.272; return (xFiboFactor);
   case 7:     xFiboFactor=1.382; return (xFiboFactor);
   case 8:     xFiboFactor=1.618; return (xFiboFactor);
   case 9:     xFiboFactor=2.000; return (xFiboFactor);
   case 10:    xFiboFactor=2.618; return (xFiboFactor); 
   default:    xFiboFactor=1.000; return (xFiboFactor);
   
   }
   return (xFiboFactor);
}
